/*********************************************************************************
 * Filename:  iscsi_target_nodeattrib.h
 *
 * This file contains the Initiator Node Attributes definitions and prototypes.
 *
 * Copyright (c) 2004 PyX Technologies, Inc.
 * Copyright (c) 2006 SBE, Inc.  All Rights Reserved.
 * Copyright (c) 2007 Rising Tide Software, Inc.
 *
 * Nicholas A. Bellinger <nab@kernel.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *********************************************************************************/


#ifndef ISCSI_TARGET_NODEATTRIB_H
#define ISCSI_TARGET_NODEATTRIB_H

extern void iscsi_set_default_node_attribues (iscsi_node_acl_t *);
extern int iscsi_na_dataout_timeout (iscsi_node_acl_t *, u32);
extern int iscsi_na_dataout_timeout_retries (iscsi_node_acl_t *, u32);
extern int iscsi_na_nopin_timeout (iscsi_node_acl_t *, u32);
extern int iscsi_na_nopin_response_timeout (iscsi_node_acl_t *, u32);
extern int iscsi_na_random_datain_pdu_offsets (iscsi_node_acl_t *, u32);
extern int iscsi_na_random_datain_seq_offsets (iscsi_node_acl_t *, u32);
extern int iscsi_na_random_r2t_offsets (iscsi_node_acl_t *, u32);
extern int iscsi_na_default_erl (iscsi_node_acl_t *, u32);

#endif /* ISCSI_TARGET_NODEATTRIB_H */
