/*
 * GPIO Functions
 *
 * LED Switch for Z1N511, Walker Chen, 2010/5/14
 * Power off for Z1N511, Walker Chen, 2010/5/14
 *
 * Disk Functions
 * clrenv for Oxford U-Boot, Walker Chen, 2010/5/21
 * qazwsx for U-boot, Walker Chen, 2010/5/27
 * 
 */
 
 
#include <common.h>
#include <command.h>


//#ifdef CONFIG_CMD_LED
  
  
int cmd_led (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{       


//	int i;
//	printf("do CMD_LED argc:%d\n", argc);
//	for (i = 0; i < argc; i++) printf("argv[%d]:%s:\n", i, argv[i]);


        if (strncmp(argv[1],"1",1) == 0) {  //  LED on
        disable_interrupts();	
				*(volatile u32*)GPIO_2_OE  	|=  (1<<5); // GPIO2-5 set to be output
        *(volatile u32*)GPIO_2_OUT  |=  (1<<5); // GPIO2-5 set to be hight
               
        }else if (strncmp(argv[1],"0",1) == 0) {  // LED off
        disable_interrupts();
				*(volatile u32*)GPIO_2_OE  	|=  (1<<5); // GPIO2-5 set to be output
        *(volatile u32*)GPIO_2_OUT  &= ~(1<<5); // GPIO2-5 set to be low
        
    		}else if(strncmp(argv[1],"a",1) == 0){
    		printf ("enable_interrupts\n");
    		enable_interrupts();
    		
 				}else if(strncmp(argv[1],"z",1) == 0){
    		printf ("disable_interrupts\n");    			
  			disable_interrupts();  		  			 			
  			
  			}else if(strncmp(argv[1],"s",1) == 0){
  				
  			//	printf ("phy_read= %x \n",phy_read( , ) );
  				
  			}else if(strncmp(argv[1],"x",1) == 0){	

    		}else{
    		printf ("LED is %s %s \n",
    			(*(volatile u32*)GPIO_2_OE&(1<<5))?"OUTPUT":"INPUT",
    			(*(volatile u32*)GPIO_2_OUT&(1<<5))?"HIGHT":"LOW" );
    		printf ("Timer is 0x%4X \n", ((*(volatile ushort *)(CFG_TIMERBASE+4)) & 0xFFFFUL));
    		
    		}
return (0);

}


int cmd_poweroff (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{ 
				/*
  			printf ("!!!Waring!!! System Low Power\n");
				printf ("[*******--------------------]\n");
				udelay(2500000);
				printf ("!!!Waring!!! Syatem No Power \n");
				printf ("[*--------------------------]\n");
				udelay(1500000);
				printf ("System is Shoutdown Now\n");
				*/				
				*(volatile u32*)GPIO_1_OE	 	|=  (1<<29); // GPIO1-29 set to be output
        *(volatile u32*)GPIO_1_OUT 	|=  (1<<29); // GPIO1-29 set to be hight

return(0);
}

int cmd_clrenv (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{ 
    		printf ("clear environment \n");
    		clrenv();

return(0);
}


int cmd_qazwsx (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{ 
	
				unsigned long sector_buffer1[128],sector_buffer2[128];
						
				if(strncmp(argv[1],"hide",4) == 0){
	
		    		/* Read MBR and partion table from the Sector-0 area on disk-0 */    			
		        unsigned long read = ide_read(0, 0, 1, &sector_buffer1);// device, sector , count , &buffer    		    		
		    		if(read!=1) printf ("Disk read is error!!! \n");
		
						/* Read hide MBR and partion table from the Sector-8 area on disk-0 */  
						read = ide_read(0, 8, 1, &sector_buffer2);// device, sector , count , &buffer    		    		
		    		if(read!=1) printf ("Disk read is error!!! \n");
		    		
		    		
		    		unsigned int mbrmark1= sector_buffer1[127] >> 16; //MBR signature is 0xAA55 
		    		unsigned int mbrmark2= sector_buffer2[127] >> 16; //MBR signature is 0xAA55			
		   			   			
		    		if ( mbrmark1==0xaa55 && mbrmark2!=0xaa55 ){
		
						/* write hide MBR and partion table to the Sector-8 area on disk-0 */  
						unsigned long write = ide_write(0, 8, 1, &sector_buffer1 );// device, sector , count , &buffer    		    		
		    		if(write!=1) printf ("Disk write is error!!! \n");
		
				
						// copy 4'th partion to 1'st partion in partion table
						sector_buffer1[111] =   sector_buffer1[123] & 0xffff0000;
						sector_buffer1[112] =   sector_buffer1[124]; 
						sector_buffer1[113] =   sector_buffer1[125];
						sector_buffer1[114] =   sector_buffer1[126];
						sector_buffer1[115] =   sector_buffer1[127] & 0x0000ffff;
						
						// clear 2'nd partion in partion table
						sector_buffer1[115] &= 0x0000ffff;
						sector_buffer1[116] =  0x00000000;
						sector_buffer1[117] =  0x00000000;
						sector_buffer1[118] =  0x00000000;
						sector_buffer1[119] &= 0xffff0000;
						
						// clear 3'th partion in partion table
						sector_buffer1[119] &= 0x0000ffff;
						sector_buffer1[120] =  0x00000000;
						sector_buffer1[121] =  0x00000000;
						sector_buffer1[122] =  0x00000000;
						sector_buffer1[123] &= 0xffff0000;		
						
						// clear 4'th partion in partion table
						sector_buffer1[123] &= 0x0000ffff;
						sector_buffer1[124] =  0x00000000;
						sector_buffer1[125] =  0x00000000;
						sector_buffer1[126] =  0x00000000;
						sector_buffer1[127] &= 0xffff0000;				
													
								    			
						/* write MBR and partion table to the Sector-0 area on disk-0 */  
						write = ide_write(0, 0, 1, &sector_buffer1 );// device, sector , count , &buffer    		    		
		    		if(write!=1) printf ("Disk write is error!!! \n");		    			
    						
		    		printf("finished \n");					
						return(0);
						
					  }else{
						printf("fail, you should not run [qazwsx hide] 2 times or more! \n");
						return(1);
					  }
			  
			  }else if(strncmp(argv[1],"reveal",6) == 0){
			  	
			  		int i;
						for (i=0;i<=127;i++) sector_buffer1[i]=0x00000000;  // clr sector buffer
		
						/* Read hide MBR and partion table from the Sector-8 area on disk-0 */  
						unsigned int read = ide_read(0, 8, 1, &sector_buffer2);// device, sector , count , &buffer    		    		
		    		if(read!=1) printf ("Disk read is error!!! \n");
		    			    		
		    		unsigned int mbrmark2= sector_buffer2[127] >> 16; //MBR signature is 0xAA55	
		    			
		    		if(mbrmark2==0xaa55){
		    			
						/* write hide MBR and partion table to the Sector-0 area on disk-0 */  
						unsigned long write = ide_write(0, 0, 1, &sector_buffer2);// device, sector , count , &buffer    		    		
		    		if(write!=1) printf ("Disk write is error!!! \n");		
		    			
						/* clear MBR and partion table to the Sector-8 area on disk-0 */  
						write = ide_write(0, 8, 1, &sector_buffer1);// device, sector , count , &buffer    		    		
		    		if(write!=1) printf ("Disk write is error!!! \n");			    			
		    			    			
		    		printf("finished \n");					
						return(0);
						
					  }else{
						printf("fail, no hide partion found ! \n");
						return(1);
					  }	    			
		    		   			

			  	
			  }else return(1);
			  
}



U_BOOT_CMD(
	led,     2,     1,      cmd_led,
	"led	- LED Switch\n",
	"[1/0] = on /off \n"
	"Walker's LED switch \n "
);

U_BOOT_CMD(
	poweroff,     2,     1,      cmd_poweroff,
	"poweroff - Power-OFF\n",
	"N/A \n"
	"Walker's Power-OFF Function \n "
);

U_BOOT_CMD(
	clrenv,     2,     1,      cmd_clrenv,
	"clrenv - clear environment\n",
	"N/A \n"
	"Walker's Clear environment Function \n "
);

U_BOOT_CMD(
	qazwsx,     2,     1,      cmd_qazwsx,
	"qazwsx - do qazwsx\n",
	"[hide/reveal] \n"
	"qazwsx Function \n "
);





//#endif /* CONFIG_CMD_LED */